package edu.prlab.tyler.iotgateway.cloud.services;

import edu.prlab.tyler.iotgateway.cloud.pojo.privacy.PrivacyChoice;
import edu.prlab.tyler.iotgateway.cloud.pojo.privacy.PrivacyPolicy;
import edu.prlab.tyler.iotgateway.cloud.repositories.PrivacyChoiceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Service;

import java.util.Optional;
import java.util.stream.StreamSupport;

@Service
public class PrivacyChoiceService extends CrudService<PrivacyChoice, Long> {
    private PrivacyChoiceRepository privacyChoiceRepository;

    @Autowired
    public PrivacyChoiceService(CrudRepository<PrivacyChoice, Long> repository,
                                PrivacyChoiceRepository privacyChoiceRepository) {
        super(repository);
        this.privacyChoiceRepository = privacyChoiceRepository;
    }

    public Iterable<PrivacyChoice> readPrivacyChoiceByDevice(String udn) {
        return () -> StreamSupport.stream(readll().spliterator(), false)
                .filter(choice -> choice.getPrivacyContent().getDevice().getUdn().equals(udn))
                .iterator();
    }
}
